%description: repeat user-provided operating conditions to test over vehicle mass range
%inputs: 
    % operating conditions, vehicle mass 
%outputs:
    % operating conditions repeated for each vehicle mass value

function[Soil_temp,Speed_temp,Accel_temp,PowerEnergyBoth_temp,OpCond_PowerIndex,OpCond_EnergyIndex]=func_TempCond(OpCond,TestRange)

%create a list of the soil type for each operating condition at all masses
Soil_temp=OpCond(:,4);
Soil_temp=repmat(Soil_temp,length(TestRange.VehicleMass),1);

%create a list of the vehicle speed requirement for each op cond & mass
Speed_temp=OpCond(:,2);
Speed_temp=repmat(Speed_temp,length(TestRange.VehicleMass),1);

%create a list of the vehicle acceleration requirement for each op cond & mass
Accel_temp=OpCond(:,3);
Accel_temp=repmat(Accel_temp,length(TestRange.VehicleMass),1);

%create a list of the power/energy/both requirements for each op cond & mass
PowerEnergyBoth_temp=OpCond(:,5);
PowerEnergyBoth_temp=repmat(PowerEnergyBoth_temp,length(TestRange.VehicleMass),1);
    %create index inside opcond to reference power/energy/or both
    OpCond_PowerIndex=find(OpCond(:,5)==0 | OpCond(:,5)==2);
    OpCond_EnergyIndex=find(OpCond(:,5)==1 | OpCond(:,5)==2);
