%description: plot terramechanics tables for a particular wheel *load wheel table first*
%inputs:
    % use 'find' to replace the soil type (eg ClayedSoil) with desired soil type
    % change figure settings (eg font_size)
%outpus:
    % figures

% use find to replace soil type:
    %LooseAirDrySand
    %MediumSoil
    %ClayedSoil

%% Normal Load
figure(1); clf
unload_index_low=1;
unload_index_hi=6;
font_size=15;
tick_font_size=12;

subplot(1,2,1);
mesh(Wheel.slip_range,Wheel.thetaf_range.*(180/pi),Wheel.ClayedSoil.PosNormalLookup(:,:,unload_index_low))
xlabel('wheel slip', 'FontSize', font_size)
ylabel('entry contact angle \theta_f (deg)', 'FontSize', font_size)
zlabel('normal force (N)', 'FontSize', font_size);
title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_low)),' (m)'], 'FontSize', font_size);
zlim([min(min(min(Wheel.ClayedSoil.PosNormalLookup))) max(max(Wheel.ClayedSoil.PosNormalLookup(:,:,unload_index_hi)))]);
set(gca,'CLim',[min(min(Wheel.ClayedSoil.PosNormalLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosNormalLookup(:,:,unload_index_hi)))]);
set(gca,'FontSize',tick_font_size)

subplot(1,2,2);
mesh(Wheel.slip_range,Wheel.thetaf_range.*(180/pi),Wheel.ClayedSoil.PosNormalLookup(:,:,unload_index_hi))
xlabel('wheel slip', 'FontSize', font_size)
ylabel('entry contact angle \theta_f (deg)', 'FontSize', font_size)
zlabel('normal force (N)', 'FontSize', font_size);
title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_hi)),' (m)'], 'FontSize', font_size);
zlim([min(min(min(Wheel.ClayedSoil.PosNormalLookup))) max(max(Wheel.ClayedSoil.PosNormalLookup(:,:,unload_index_hi)))]);
set(gca,'CLim',[min(min(Wheel.ClayedSoil.PosNormalLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosNormalLookup(:,:,unload_index_hi)))]);
set(gca,'FontSize',tick_font_size)

%% Thrust Force

figure(2); clf

subplot(1,2,1);
mesh(Wheel.slip_range,Wheel.thetaf_range.*(180/pi),Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_low))
xlabel('wheel slip', 'FontSize', font_size)
ylabel('entry contact angle \theta_f (deg)', 'FontSize', font_size)
zlabel('thrust force (N)', 'FontSize', font_size);
title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_low)),' (m)'], 'FontSize', font_size);
zlim([min(min(Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi)))]);
set(gca,'CLim',[min(min(Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi)))]);
set(gca,'FontSize',tick_font_size)

subplot(1,2,2);
mesh(Wheel.slip_range,Wheel.thetaf_range.*(180/pi),Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi))
xlabel('wheel slip', 'FontSize', font_size)
ylabel('entry contact angle \theta_f (deg)', 'FontSize', font_size)
zlabel('thrust force (N)', 'FontSize', font_size);
title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_hi)),' (m)'], 'FontSize', font_size);
zlim([min(min(Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi)))]);
set(gca,'CLim',[min(min(Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosForceLookup(:,:,unload_index_hi)))]);
set(gca,'FontSize',tick_font_size)


%% Resistance Force

figure(3); clf

subplot(1,2,1);
mesh(Wheel.slip_range,Wheel.thetaf_range.*(180/pi),Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_low))
xlabel('wheel slip', 'FontSize', font_size)
ylabel('entry contact angle \theta_f (deg)', 'FontSize', font_size)
zlabel('resistance force (N)', 'FontSize', font_size);
title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_low)),' (m)'], 'FontSize', font_size);
zlim([min(min(Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi)))]);
set(gca,'CLim',[min(min(Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi)))]);
set(gca,'FontSize',tick_font_size)

subplot(1,2,2);
mesh(Wheel.slip_range,Wheel.thetaf_range.*(180/pi),Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi))
xlabel('wheel slip', 'FontSize', font_size)
ylabel('entry contact angle \theta_f (deg)', 'FontSize', font_size)
zlabel('resistance force (N)', 'FontSize', font_size);
title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_hi)),' (m)'], 'FontSize', font_size);
zlim([min(min(Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi)))]);
set(gca,'CLim',[min(min(Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.PosResistLookup(:,:,unload_index_hi)))]);
set(gca,'FontSize',tick_font_size)

%% Contact Angle

figure(4); clf

%find max normal force:
temp=Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi);
[temp_row,temp_col]=find(isnan(temp)==0);
temp_max_index=max(temp_row);

subplot(1,2,1);
mesh(Wheel.slip_range,Wheel.ClayedSoil.NormalForceRange,Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_low))
xlabel('wheel slip', 'FontSize', font_size)
ylabel('normal force (N)', 'FontSize', font_size)
zlabel('entry contact angle   \theta_f (deg)', 'FontSize', font_size);
title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_low)),' (m)'], 'FontSize', font_size);
zlim([min(min(Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi)))]);
ylim([min(Wheel.ClayedSoil.NormalForceRange) Wheel.ClayedSoil.NormalForceRange(temp_max_index)]);
set(gca,'CLim',[min(min(Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi)))]);
set(gca,'FontSize',tick_font_size)

subplot(1,2,2);
mesh(Wheel.slip_range,Wheel.ClayedSoil.NormalForceRange,Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi))
xlabel('wheel slip', 'FontSize', font_size)
ylabel('normal force (N)', 'FontSize', font_size)
zlabel('entry contact angle   \theta_f (deg)', 'FontSize', font_size);
title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_hi)),' (m)'], 'FontSize', font_size);
zlim([min(min(Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi)))]);
ylim([min(Wheel.ClayedSoil.NormalForceRange) Wheel.ClayedSoil.NormalForceRange(temp_max_index)]);
set(gca,'CLim',[min(min(Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi))) max(max(Wheel.ClayedSoil.ContactAngleLookup(:,:,unload_index_hi)))]);
set(gca,'FontSize',tick_font_size)


%% Unloading Sinkage

figure(5); clf

mesh(Wheel.unloadsink_range,Wheel.thetaf_range.*(180/pi),Wheel.ClayedSoil.MaxSinkageLookup)
xlabel('unloading sinkage (m)', 'FontSize', font_size)
ylabel('entry contact angle   \theta_f (deg)', 'FontSize', font_size)
zlabel('wheel_{n+1} unloading sinkage (m)', 'FontSize', font_size);
% title(['unloading sinkage z_u = ',num2str(Wheel.unloadsink_range(unload_index_low)),' (m)']);
zlim([min(min(Wheel.ClayedSoil.MaxSinkageLookup)) max(max(Wheel.ClayedSoil.MaxSinkageLookup))]);
% set(gca,'CLim',[min(min(Wheel.ClayedSoil.MaxSinkageLookup)) max(max(Wheel.ClayedSoil.MaxSinkageLookup))]);
set(gca,'FontSize',tick_font_size)

