%description: select battery type, output battery specifications

function[Output] = populateBatteryDatabase(input)

                 %Battery Type     Specific Energy(W-s/kg from W-hr/kg)    Specific Power (W/kg)
Database(:,:) = {'Lithium-Ion',      100*3600,                              300;...
                };

switch nargin
    case 0 %no inputs - output battery types available
        Output = Database(:,1);
    case 1 %1 input - output battery specific energy/power
        temp = cell2mat(Database(input,[2,3]));
        Output.SpecificEnergy = temp(1);
        Output.SpecificPower = temp(2);
end
        
        

% Battery.SpecificEnergy = 100*3600; %[W-s/kg] converted from W-hr/kg
% Battery.SpecificPower = 300; %[W/kg]

% Fuel cell and battery electric vehicles compared 
% by C.E. Thomas
% Specific Energy, Li-Ion = 150 Whr/kg
% Specific Energy, NiMH = 75 Whr/kg

% Battery, Ultracapacitor, Fuel Cell, and Hybrid Energy Storage Systems for ...
% Electric, Hybrid Electric, Fuel Cell, and Plug-In Hybrid Electric Vehicles: State of the Art
% by Alireza Khaligh
% Specific Energy, Li-Ion = 100 Whr/kg
% Specific Power, Li-Ion = 300 W/kg